VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} MUD_ImportWord 
   Caption         =   "  Word"
   ClientHeight    =   1155
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   6780
   OleObjectBlob   =   "MUD_ImportWord.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "MUD_ImportWord"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private configs_ As Collection
Public isCancelled_ As Boolean

Private Sub UserForm_Initialize()
  isCancelled_ = True
  Set configs_ = New Collection
End Sub

Private Sub UserForm_Terminate()
  isCancelled_ = True
  Call Me.Hide
End Sub

Public Function Init()
  Dim activeConfig As ItemConfigDescriptor: Set activeConfig = SelectedConfig
  Dim selectedID&: selectedID = 0
  Set configs_ = GetConfigList
  
  Call CBConfig.Clear
  Dim nItem&
  For nItem = 1 To configs_.Count
    Dim confName$: confName = configs_.Item(nItem).name_
    Call CBConfig.AddItem(confName)
    If Not activeConfig Is Nothing Then _
      If activeConfig.name_ = confName Then _
        selectedID = nItem - 1
  Next nItem
  
  CBConfig.ListIndex = selectedID
  
  isCancelled_ = True
End Function

Public Property Get FileName() As String
  FileName = TBDocument.Text
End Property

Public Property Get SelectedConfig() As ItemConfigDescriptor
  If CBConfig.ListIndex <> -1 Then _
    Set SelectedConfig = configs_.Item(CBConfig.ListIndex + 1)
End Property

Private Sub DocumentBtn_Click()
  Dim sFileName$: sFileName = UserInteraction.PromptFileFilter( _
                                sInitialPath:=ThisWorkbook.Path, _
                                sDescription:=" Word", _
                                sFilter:="*.docx;*.doc;*.docm")
  If sFileName <> vbNullString Then _
    TBDocument.Text = sFileName
End Sub

Private Sub CancelBtn_Click()
  isCancelled_ = True
  Call Me.Hide
End Sub

Private Sub OkBtn_Click()
  If FileName = vbNullString Or SelectedConfig Is Nothing Then
    Call UserInteraction.ShowMessage(EM_VALIDATION_FAIL)
    Exit Sub
  End If
  
  isCancelled_ = False
  Call Me.Hide
End Sub
