Attribute VB_Name = "Main"
Option Explicit

Public Sub RunImportExcel()
  Dim sFileName$: sFileName = UserInteraction.PromptFileFilter( _
                                sInitialPath:=ThisWorkbook.Path, _
                                sDescription:=" Excel", _
                                sFilter:="*.xlsx;*.xls;*.xlsm")
  If sFileName = vbNullString Then _
    Exit Sub
  Dim xlApp As New API_XLWrapper
  If xlApp.OpenDocument(sFileName, bReadOnly:=True) Is Nothing Then _
    Exit Sub
  
  Dim iData As DB_Markup: Set iData = AccessData
  Dim bIsLoaded As Boolean: bIsLoaded = iData.ImportFromExcel(xlApp.Document.Sheets(1))
  Call xlApp.ReleaseDocument
  
  If bIsLoaded Then _
    Call UserInteraction.ShowMessage(IM_IMPORT_OK)
End Sub

Public Sub RunImportWord()
  Call MUD_ImportWord.Init
  Call MUD_ImportWord.Show
  If MUD_ImportWord.isCancelled_ Then _
    Exit Sub
  
  Dim theMarkup As New MarkupAPI
  If Not theMarkup.config_.Load(MUD_ImportWord.SelectedConfig.path_) Then
    Call UserInteraction.ShowMessage(EM_CANNOT_LOAD_CONFIG)
    Exit Sub
  End If
  
  Dim wordApp As New API_WordWrapper
  If wordApp.OpenDocument(MUD_ImportWord.FileName, bReadOnly:=True) Is Nothing Then _
    Exit Sub
  
  Dim iData As DB_Markup: Set iData = AccessData
  Dim iDoc As New InfoDocument: Call iDoc.Init(wordApp.Document, theMarkup)
  Call iDoc.SyncStyles
  Dim bIsLoaded As Boolean: bIsLoaded = iData.ImportFromWord(iDoc)
  Call wordApp.ReleaseDocument(bSaveChanges:=False)
  
  If bIsLoaded Then _
    Call UserInteraction.ShowMessage(IM_IMPORT_OK)
End Sub

Public Sub RunFollowLink()
  If Excel.Application.ActiveSheet.Name <> SHEET_DATA Then _
    Exit Sub
    
  Dim iData As DB_Markup: Set iData = AccessData
  Dim nSelectedRow&: nSelectedRow = Excel.Selection.Cells(1, 1).Row
  Dim iLink As ItemLink: Set iLink = iData.GetLinkFor(nSelectedRow)
  If iLink Is Nothing Then
    Call UserInteraction.ShowMessage(EM_INVALID_SOURCE)
    Exit Sub
  End If
  
  Call ShowDocumentLink(iLink)
End Sub

Public Sub RunClearAll()
  Call AccessData.RemoveAll
End Sub
