Attribute VB_Name = "MainImpl"
Option Private Module
Option Explicit

Public Function AccessData() As DB_Markup
  Static s_Data As DB_Markup
  
  If s_Data Is Nothing Then
    Set s_Data = New DB_Markup
    Call s_Data.Init(ThisWorkbook.Worksheets(SHEET_DATA), ThisWorkbook.Worksheets(SHEET_SOURCES))
  End If
  
  Set AccessData = s_Data
End Function

Public Function ShowDocumentLink(iLink As ItemLink)
  Dim fso As New Scripting.FileSystemObject
  If Not fso.FileExists(iLink.path_) Then
    Call UserInteraction.ShowMessage(EM_FILE_MISSINNG, iLink.path_)
    Exit Function
  End If
  
  Dim wordAppl As New API_WordWrapper
  If wordAppl.OpenDocument(iLink.path_, bReadOnly:=True) Is Nothing Then _
    Exit Function
  
  Dim theDoc As Word.Document: Set theDoc = wordAppl.Document
  If theDoc.Range.End < iLink.finish_ Then
    Call UserInteraction.ShowMessage(EM_FILE_TOO_SHORT)
    Exit Function
  End If
  
  Dim targetRng As Word.Range: Set targetRng = theDoc.Range(iLink.start_, iLink.finish_)
  Call targetRng.Select
  Call theDoc.ActiveWindow.ScrollIntoView(targetRng)
  
  Call ActivateWindowHwnd(theDoc.ActiveWindow.hwnd)
End Function


