Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  EM_VALIDATION_FAIL
  EM_CANNOT_LOAD_CONFIG
  EM_FILE_MISSINNG
  EM_FILE_TOO_SHORT
  EM_INVALID_SOURCE
  
  IM_IMPORT_OK

  QM_CLEAR_BEFORE_READD
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_VALIDATION_FAIL:          Call MsgBox("  ", vbExclamation)
  Case EM_CANNOT_LOAD_CONFIG:       Call MsgBox("   ", vbExclamation)
  Case EM_FILE_MISSINNG:            Call MsgBox(Fmt("  : {1}", unwrapped), vbExclamation)
  Case EM_FILE_TOO_SHORT:           Call MsgBox("   ,    ", vbExclamation)
  Case EM_INVALID_SOURCE:           Call MsgBox("  :   ", vbExclamation)
    
  Case IM_IMPORT_OK:                Call MsgBox("   ", vbInformation)
    
  Case Else:                        Call MsgBox("Invalid message code", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
  Case QM_CLEAR_BEFORE_READD
    answer = MsgBox("     .      ?", vbYesNo + vbQuestion)
        
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
