VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "InfoCategory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public id_ As Long
Public name_ As String
Public info_ As String
Public style_ As String
Public composition_ As Scripting.Dictionary

Private Sub Class_Initialize()
  Set composition_ = New Scripting.Dictionary
End Sub

Public Function InitBasic(nID&, sName$, Optional sInfo$ = "")
  id_ = nID
  name_ = sName
  info_ = sInfo
End Function

Public Function Clone() As InfoCategory
  Set Clone = New InfoCategory
  With Clone
    .id_ = id_
    .name_ = name_
    .info_ = info_
    .style_ = style_
  End With
  
  Dim iBasic As Variant
  For Each iBasic In composition_
    Call Clone.composition_.Add(iBasic, composition_(iBasic))
  Next iBasic
End Function

Public Property Get IsCombo() As Boolean
  IsCombo = composition_.Count > 1
End Property

Public Property Get IsComplete() As Boolean
  IsComplete = style_ <> vbNullString
End Property

Public Function ImportComposition(sComposition$) As Boolean
  ImportComposition = False
  
  Call composition_.RemoveAll
  Dim sPart As Variant
  For Each sPart In VBA.Split(sComposition, SPLITTER_COMPOSITION)
    Dim sID$: sID = Trim(sPart)
    If Not IsNumeric(sID) Then _
      Exit Function
    Call composition_.Add(VBA.CLng(sID), 0)
  Next sPart
    
  ImportComposition = True
End Function

Public Function GetCompositionString() As String
  Dim sComposition$: sComposition = ""
  Dim catID As Variant
  For Each catID In composition_
    If sComposition <> "" Then _
      sComposition = sComposition & SPLITTER_COMPOSITION & " "
    sComposition = sComposition & catID
  Next catID
  GetCompositionString = sComposition
End Function

Public Function GetFormat(iDoc As Word.Document) As InfoFormat
  If Not IsComplete Then _
    Exit Function
  Dim frs As New InfoFormat: Call frs.InitFromWordDiff(iDoc.Styles(wdStyleNormal), iDoc.Styles(style_))
  Set GetFormat = frs
End Function

Public Function IsIncludedIn(anotherCat As InfoCategory) As Boolean
  If Not IsCombo Then
    IsIncludedIn = anotherCat.composition_.Exists(id_)
    Exit Function
  End If
  
  IsIncludedIn = False
  Dim iBasic As Variant
  For Each iBasic In composition_
    If Not anotherCat.composition_.Exists(iBasic) Then _
      Exit Function
  Next iBasic
  IsIncludedIn = True
End Function
