VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorStyle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'       
Option Explicit

Private selection_ As Word.Range
Private styles_ As Collection

Public Function Init(theDoc As Word.Document, searchWhat As Collection, Optional nStart& = 0)
  Set styles_ = searchWhat
  Set selection_ = theDoc.Range(nStart, nStart)
End Function

Public Function Range() As Word.Range
  Set Range = selection_
End Function

Public Function MoveNext() As Word.Range
  Set MoveNext = IIf(Increment(True), selection_, Nothing)
End Function

Public Function MovePrev() As Word.Range
  Set MovePrev = IIf(Increment(False), selection_, Nothing)
End Function

' =========
Private Function Increment(bForward As Boolean) As Boolean
  Increment = False
  If Not IncrementOnce(bForward) Then _
    Exit Function
  
  Dim nStart&: nStart = selection_.Start
  Dim nFinish&: nFinish = selection_.End
  Do
    Call IncrementOnce(bForward)
    If selection_.Start <> nFinish Then _
      Exit Do
    nFinish = selection_.End
  Loop
  
  Set selection_ = selection_.Document.Range(nStart, nFinish)
  Increment = True
End Function

Private Function IncrementOnce(bForward As Boolean)
  IncrementOnce = False
  
  Dim iFoundIntervals As New CDS_CompoundIntervals
  Dim sStyle As Variant
  For Each sStyle In styles_
    Dim rOption As Word.Range: Set rOption = IncrementStyle(CStr(sStyle), bForward)
    If Not rOption Is Nothing Then _
      Call iFoundIntervals.AddItem(rOption.Start, rOption.End)
  Next sStyle
  If iFoundIntervals.IsEmpty Then _
    Exit Function
  
  Dim iResult As CDS_Interval: Set iResult = iFoundIntervals.items_(1)
  Dim rAlt As CDS_Interval
  For Each rAlt In iFoundIntervals.items_
    If bForward Then
      If iResult.start_ > rAlt.start_ Then _
        Set iResult = rAlt
    Else
      If iResult.finish_ < rAlt.finish_ Then _
        Set iResult = rAlt
    End If
  Next rAlt
  
  Set selection_ = selection_.Document.Range(iResult.start_, iResult.finish_)
  IncrementOnce = True
End Function

Private Function IncrementStyle(sStyle$, bForward As Boolean) As Word.Range
  Dim theDoc As Word.Document: Set theDoc = selection_.Document
  Dim rSearch As Word.Range: Set rSearch = selection_.Duplicate
  Call rSearch.Collapse(IIf(bForward, wdCollapseEnd, wdCollapseStart))
  
  rSearch.Find.Forward = bForward
  rSearch.Find.Style = sStyle
  rSearch.Find.Format = True
  If Not rSearch.Find.Execute Then _
    Exit Function
  
  Set IncrementStyle = rSearch.Duplicate
  If rSearch.End = theDoc.Range.End Then _
    Exit Function
  
  
  If theDoc.Range(rSearch.End, rSearch.End + 1).Text <> "" Then _
    Exit Function
    
  Call rSearch.Collapse(IIf(bForward, wdCollapseEnd, wdCollapseStart))
  If Not rSearch.Find.Execute Then _
    Exit Function
    
  If rSearch.Start = IncrementStyle.End + 1 Then _
    IncrementStyle.End = rSearch.End
End Function



