VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MarkupAPI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'================ API   =========================
Option Explicit

Public config_ As InfoConfig

Private Sub Class_Initialize()
  Set config_ = New InfoConfig
End Sub

Public Function LoadConfig(sConfig$) As Boolean
  LoadConfig = config_.Load(sConfig)
End Function

Public Function InitFromCurrentDocument(target As Word.Document) As Boolean
  InitFromCurrentDocument = False
  
  Dim sConfig$: sConfig = GetMetadata(target, VAR_MUPATH)
  If sConfig = "" Then _
    Exit Function
    
  InitFromCurrentDocument = LoadConfig(sConfig)
  If InitFromCurrentDocument Then
    Call config_.SyncDocument(target)
  Else
    Call SetMetadata(target, VAR_MUPATH, "")
    Call SetMetadata(target, VAR_HASH, "")
  End If
End Function

Public Function ValidateConfig(styleDoc As Word.Document) As String
  Dim sLog$
  Dim errCount&
  Dim iCat As InfoCategory
  Dim catID As Variant
  For Each catID In config_.categories_
    Set iCat = config_.categories_(catID)
    If Not iCat.IsComplete Then
      errCount = errCount + 1
      sLog = sLog & "  : " & iCat.name_ & vbNewLine
    Else
      errCount = errCount + CheckStyleSimilarity(sLog, iCat, styleDoc)
    End If
  Next catID
  
  If errCount = 0 Then
    ValidateConfig = "  "
  Else
    ValidateConfig = " " & vbNewLine & VBA.Right(sLog, VBA.Len(sLog) - 1)
  End If
End Function

Public Function SyncWord(target As Word.Document) As Boolean
  SyncWord = False
  If Not config_.IsLoaded Then _
    Exit Function
  
  Call config_.SyncDocument(target)

  SyncWord = True
End Function

' ===========
Private Function CheckStyleSimilarity(ByRef sLog$, iCat1 As InfoCategory, styleDoc As Word.Document) As Long
  Dim iCat2 As InfoCategory
  Dim catID As Variant
  For Each catID In config_.categories_
    Set iCat2 = config_.categories_(catID)
    If iCat2.style_ = "" Or iCat1.id_ = iCat2.id_ Then _
      GoTo NEXT_CAT
    
    Dim frs As New InfoFormat: Call frs.InitFromWordDiff(styleDoc.Styles(iCat1.style_), styleDoc.Styles(iCat2.style_))
    If frs.IsEmpty Then
      CheckStyleSimilarity = CheckStyleSimilarity + 1
      sLog = sLog & " : " & iCat1.style_ & " == " & iCat2.style_ & vbNewLine
    End If
NEXT_CAT:
  Next catID
End Function
