Attribute VB_Name = "DevHelper"
Option Explicit

Private Const TEST_SOURCES = "test"
Private Const TEST_CONFIG = "TestConfig.docx"

Private Const TEST_FILES = "testFiles"

Public Function Dev_PrepareSkeleton()
  ' Do nothing
End Function

Public Sub Dev_ManualRunTest()
  Dim sSuite$: sSuite = "s_WordDocument"
  Dim sTest$: sTest = "t_AddCategory"
  Dim sMsg$: sMsg = Dev_RunTestDebug(sSuite, sTest)
  Debug.Print sMsg
  Call MsgBox(sMsg)
End Sub

Public Function Dev_GetTestSuite(sName$) As Object
  Select Case sName
    Case "s_WordDocument": Set Dev_GetTestSuite = New s_WordDocument
    Case "s_MarkupAPI": Set Dev_GetTestSuite = New s_MarkupAPI
    Case "s_Format": Set Dev_GetTestSuite = New s_Format
    Case "s_Category": Set Dev_GetTestSuite = New s_Category
    Case "s_Config": Set Dev_GetTestSuite = New s_Config
  End Select
End Function

Public Function GetTestFolder() As String
  Dim fso As New Scripting.FileSystemObject
  GetTestFolder = fso.GetParentFolderName(ThisDocument.Path)
  GetTestFolder = GetTestFolder & "\" & TEST_FILES
End Function

Public Function ResetTestFolder()
  Dim sFolder$: sFolder = GetTestFolder
  Dim fso As New Scripting.FileSystemObject
  On Error Resume Next
  Call fso.DeleteFolder(sFolder)
  On Error GoTo 0
  Call EnsureFolderExists(sFolder, fso)
End Function

Public Function SetupTestConfig() As String
  Dim fso As New Scripting.FileSystemObject
  Dim sSource$: sSource = fso.GetParentFolderName(ThisDocument.Path) & "\" & TEST_SOURCES & "\" & TEST_CONFIG
  Dim sTest$: sTest = GetTestFolder & "\" & TEST_CONFIG
  Call fso.CopyFile(sSource, sTest)
  SetupTestConfig = sTest
End Function
