Attribute VB_Name = "Main"
Option Explicit

Public Sub RunImport()
  Dim sFileName$: sFileName = UserInteraction.PromptFileFilter( _
                                ThisWorkbook.Path, _
                                sDescription:=" Excel", _
                                sFilter:="*.xlsx;*.xls;*.xlsm")
  If sFileName = vbNullString Then _
    Exit Sub

  Dim xlApp As New API_XLWrapper
  If xlApp.OpenDocument(sFileName, bReadOnly:=True) Is Nothing Then
    Call UserInteraction.ShowMessage(EM_IMPORT_FAILED)
    Exit Sub
  End If

  Dim uiWrap As New API_XLWrapper: Call uiWrap.SetDocument(ThisWorkbook)
  Call uiWrap.PauseUI
  
  Call ImportFrom(xlApp.Document)
  Call xlApp.ReleaseDocument
  
  Call uiWrap.ResumeUI
  
  Call UserInteraction.ShowMessage(IM_IMPORT_OK)
End Sub
