Attribute VB_Name = "MainImpl"
Option Explicit

Public Function ImportFrom(wbSource As Excel.Workbook)
  Dim dest As Excel.Worksheet: Set dest = ThisWorkbook.Sheets(SHT_DATA)
  Dim src As Excel.Worksheet: Set src = wbSource.Sheets(1)
  
  Dim rowOut&: rowOut = 2
  Do While dest.Cells(rowOut, 1) <> vbNullString
    rowOut = rowOut + 1
  Loop
  
  Dim idRows As New Collection
  Dim rowIn&: rowIn = 2
  Dim lastType&: lastType = TYPE_NO_TYPE
  Dim lastEnd&: lastEnd = 0
  Dim lastID$: lastID = vbNullString
  Dim targetRow&
  Do While src.Cells(rowIn, 1) <> vbNullString
    Dim sID$: sID = src.Cells(rowIn, INPS_COMMENT)
    Dim nColumn&: nColumn = TypeToStruct(src.Cells(rowIn, INPS_TYPE))
    
    If sID = vbNullString Then
      sID = DATA_DEFAULT_ID
      targetRow = rowOut
      rowOut = rowOut + 1
    ElseIf InCollection(sID, idRows) Then
      targetRow = idRows.Item(sID)
    Else
      Call idRows.Add(rowOut, sID)
      targetRow = rowOut
      rowOut = rowOut + 1
    End If
    
    dest.Cells(targetRow, IS_ID) = sID
    If sID = lastID And src.Cells(rowIn, INPS_TYPE) = lastType And src.Cells(rowIn, INPS_START) = lastEnd Then
      Call ConcatinateCell(dest.Cells(targetRow, nColumn), src.Cells(rowIn, INPS_TEXT).Text)
    Else
      Call AddToCell(dest.Cells(targetRow, nColumn), src.Cells(rowIn, INPS_TEXT).Text)
    End If
    
    lastType = src.Cells(rowIn, INPS_TYPE)
    lastID = sID
    lastEnd = src.Cells(rowIn, INPS_FINISH)
    rowIn = rowIn + 1
  Loop
End Function

' ==========
Private Function TypeToStruct(styleType&) As ItemStructure
  TypeToStruct = styleType + 1
End Function

Private Function AddToCell(target As Excel.Range, sData$)
  Dim newTxt$: newTxt = sData
  If target.Text <> vbNullString Then
    newTxt = target.Text & Chr(10) & "------" & Chr(10) & sData
  End If
  target = newTxt
  target.WrapText = False
End Function

Private Function ConcatinateCell(target As Excel.Range, sData$)
  Dim newTxt$: newTxt = sData
  If target.Text <> vbNullString Then
    newTxt = target.Text & Chr(10) & newTxt
  End If
  target = newTxt
  target.WrapText = False
End Function
